submodules: ensure clean environment when operating in a submodule
[git] / git-stash.sh
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
3
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6    or: $dashless show [<stash>]
7    or: $dashless drop [-q|--quiet] [<stash>]
8    or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9    or: $dashless branch <branchname> [<stash>]
10    or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet] [<message>]]
11    or: $dashless clear"
12
13 SUBDIRECTORY_OK=Yes
14 OPTIONS_SPEC=
15 . git-sh-setup
16 require_work_tree
17 cd_to_toplevel
18
19 TMP="$GIT_DIR/.git-stash.$$"
20 trap 'rm -f "$TMP-*"' 0
21
22 ref_stash=refs/stash
23
24 if git config --get-colorbool color.interactive; then
25        help_color="$(git config --get-color color.interactive.help 'red bold')"
26        reset_color="$(git config --get-color '' reset)"
27 else
28        help_color=
29        reset_color=
30 fi
31
32 no_changes () {
33         git diff-index --quiet --cached HEAD --ignore-submodules -- &&
34         git diff-files --quiet --ignore-submodules
35 }
36
37 clear_stash () {
38         if test $# != 0
39         then
40                 die "git stash clear with parameters is unimplemented"
41         fi
42         if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
43         then
44                 git update-ref -d $ref_stash $current
45         fi
46 }
47
48 create_stash () {
49         stash_msg="$1"
50
51         git update-index -q --refresh
52         if no_changes
53         then
54                 exit 0
55         fi
56
57         # state of the base commit
58         if b_commit=$(git rev-parse --verify HEAD)
59         then
60                 head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
61         else
62                 die "You do not have the initial commit yet"
63         fi
64
65         if branch=$(git symbolic-ref -q HEAD)
66         then
67                 branch=${branch#refs/heads/}
68         else
69                 branch='(no branch)'
70         fi
71         msg=$(printf '%s: %s' "$branch" "$head")
72
73         # state of the index
74         i_tree=$(git write-tree) &&
75         i_commit=$(printf 'index on %s\n' "$msg" |
76                 git commit-tree $i_tree -p $b_commit) ||
77                 die "Cannot save the current index state"
78
79         if test -z "$patch_mode"
80         then
81
82                 # state of the working tree
83                 w_tree=$( (
84                         rm -f "$TMP-index" &&
85                         cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
86                         GIT_INDEX_FILE="$TMP-index" &&
87                         export GIT_INDEX_FILE &&
88                         git read-tree -m $i_tree &&
89                         git add -u &&
90                         git write-tree &&
91                         rm -f "$TMP-index"
92                 ) ) ||
93                         die "Cannot save the current worktree state"
94
95         else
96
97                 rm -f "$TMP-index" &&
98                 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
99
100                 # find out what the user wants
101                 GIT_INDEX_FILE="$TMP-index" \
102                         git add--interactive --patch=stash -- &&
103
104                 # state of the working tree
105                 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
106                 die "Cannot save the current worktree state"
107
108                 git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
109                 test -s "$TMP-patch" ||
110                 die "No changes selected"
111
112                 rm -f "$TMP-index" ||
113                 die "Cannot remove temporary index (can't happen)"
114
115         fi
116
117         # create the stash
118         if test -z "$stash_msg"
119         then
120                 stash_msg=$(printf 'WIP on %s' "$msg")
121         else
122                 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
123         fi
124         w_commit=$(printf '%s\n' "$stash_msg" |
125                 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
126                 die "Cannot record working tree state"
127 }
128
129 save_stash () {
130         keep_index=
131         patch_mode=
132         while test $# != 0
133         do
134                 case "$1" in
135                 -k|--keep-index)
136                         keep_index=t
137                         ;;
138                 --no-keep-index)
139                         keep_index=
140                         ;;
141                 -p|--patch)
142                         patch_mode=t
143                         keep_index=t
144                         ;;
145                 -q|--quiet)
146                         GIT_QUIET=t
147                         ;;
148                 --)
149                         shift
150                         break
151                         ;;
152                 -*)
153                         echo "error: unknown option for 'stash save': $1"
154                         usage
155                         ;;
156                 *)
157                         break
158                         ;;
159                 esac
160                 shift
161         done
162
163         stash_msg="$*"
164
165         git update-index -q --refresh
166         if no_changes
167         then
168                 say 'No local changes to save'
169                 exit 0
170         fi
171         test -f "$GIT_DIR/logs/$ref_stash" ||
172                 clear_stash || die "Cannot initialize stash"
173
174         create_stash "$stash_msg"
175
176         # Make sure the reflog for stash is kept.
177         : >>"$GIT_DIR/logs/$ref_stash"
178
179         git update-ref -m "$stash_msg" $ref_stash $w_commit ||
180                 die "Cannot save the current status"
181         say Saved working directory and index state "$stash_msg"
182
183         if test -z "$patch_mode"
184         then
185                 git reset --hard ${GIT_QUIET:+-q}
186
187                 if test -n "$keep_index" && test -n $i_tree
188                 then
189                         git read-tree --reset -u $i_tree
190                 fi
191         else
192                 git apply -R < "$TMP-patch" ||
193                 die "Cannot remove worktree changes"
194
195                 if test -z "$keep_index"
196                 then
197                         git reset
198                 fi
199         fi
200 }
201
202 have_stash () {
203         git rev-parse --verify $ref_stash >/dev/null 2>&1
204 }
205
206 list_stash () {
207         have_stash || return 0
208         git log --format="%gd: %gs" -g "$@" $ref_stash --
209 }
210
211 show_stash () {
212         flags=$(git rev-parse --no-revs --flags "$@")
213         if test -z "$flags"
214         then
215                 flags=--stat
216         fi
217
218         w_commit=$(git rev-parse --verify --default $ref_stash "$@") &&
219         b_commit=$(git rev-parse --verify "$w_commit^") &&
220         git diff $flags $b_commit $w_commit
221 }
222
223 apply_stash () {
224         applied_stash=
225         unstash_index=
226
227         while test $# != 0
228         do
229                 case "$1" in
230                 --index)
231                         unstash_index=t
232                         ;;
233                 -q|--quiet)
234                         GIT_QUIET=t
235                         ;;
236                 *)
237                         break
238                         ;;
239                 esac
240                 shift
241         done
242
243         if test $# = 0
244         then
245                 have_stash || die 'Nothing to apply'
246                 applied_stash="$ref_stash@{0}"
247         else
248                 applied_stash="$*"
249         fi
250
251         # stash records the work tree, and is a merge between the
252         # base commit (first parent) and the index tree (second parent).
253         s=$(git rev-parse --quiet --verify --default $ref_stash "$@") &&
254         w_tree=$(git rev-parse --quiet --verify "$s:") &&
255         b_tree=$(git rev-parse --quiet --verify "$s^1:") &&
256         i_tree=$(git rev-parse --quiet --verify "$s^2:") ||
257                 die "$*: no valid stashed state found"
258
259         git update-index -q --refresh &&
260         git diff-files --quiet --ignore-submodules ||
261                 die 'Cannot apply to a dirty working tree, please stage your changes'
262
263         # current index state
264         c_tree=$(git write-tree) ||
265                 die 'Cannot apply a stash in the middle of a merge'
266
267         unstashed_index_tree=
268         if test -n "$unstash_index" && test "$b_tree" != "$i_tree" &&
269                         test "$c_tree" != "$i_tree"
270         then
271                 git diff-tree --binary $s^2^..$s^2 | git apply --cached
272                 test $? -ne 0 &&
273                         die 'Conflicts in index. Try without --index.'
274                 unstashed_index_tree=$(git write-tree) ||
275                         die 'Could not save index tree'
276                 git reset
277         fi
278
279         eval "
280                 GITHEAD_$w_tree='Stashed changes' &&
281                 GITHEAD_$c_tree='Updated upstream' &&
282                 GITHEAD_$b_tree='Version stash was based on' &&
283                 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
284         "
285
286         if test -n "$GIT_QUIET"
287         then
288                 export GIT_MERGE_VERBOSITY=0
289         fi
290         if git merge-recursive $b_tree -- $c_tree $w_tree
291         then
292                 # No conflict
293                 if test -n "$unstashed_index_tree"
294                 then
295                         git read-tree "$unstashed_index_tree"
296                 else
297                         a="$TMP-added" &&
298                         git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
299                         git read-tree --reset $c_tree &&
300                         git update-index --add --stdin <"$a" ||
301                                 die "Cannot unstage modified files"
302                         rm -f "$a"
303                 fi
304                 squelch=
305                 if test -n "$GIT_QUIET"
306                 then
307                         squelch='>/dev/null 2>&1'
308                 fi
309                 eval "git status $squelch" || :
310         else
311                 # Merge conflict; keep the exit status from merge-recursive
312                 status=$?
313                 if test -n "$unstash_index"
314                 then
315                         echo >&2 'Index was not unstashed.'
316                 fi
317                 exit $status
318         fi
319 }
320
321 drop_stash () {
322         have_stash || die 'No stash entries to drop'
323
324         while test $# != 0
325         do
326                 case "$1" in
327                 -q|--quiet)
328                         GIT_QUIET=t
329                         ;;
330                 *)
331                         break
332                         ;;
333                 esac
334                 shift
335         done
336
337         if test $# = 0
338         then
339                 set x "$ref_stash@{0}"
340                 shift
341         fi
342         # Verify supplied argument looks like a stash entry
343         s=$(git rev-parse --verify "$@") &&
344         git rev-parse --verify "$s:"   > /dev/null 2>&1 &&
345         git rev-parse --verify "$s^1:" > /dev/null 2>&1 &&
346         git rev-parse --verify "$s^2:" > /dev/null 2>&1 ||
347                 die "$*: not a valid stashed state"
348
349         git reflog delete --updateref --rewrite "$@" &&
350                 say "Dropped $* ($s)" || die "$*: Could not drop stash entry"
351
352         # clear_stash if we just dropped the last stash entry
353         git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
354 }
355
356 apply_to_branch () {
357         have_stash || die 'Nothing to apply'
358
359         test -n "$1" || die 'No branch name specified'
360         branch=$1
361
362         if test -z "$2"
363         then
364                 set x "$ref_stash@{0}"
365         fi
366         stash=$2
367
368         git checkout -b $branch $stash^ &&
369         apply_stash --index $stash &&
370         drop_stash $stash
371 }
372
373 # The default command is "save" if nothing but options are given
374 seen_non_option=
375 for opt
376 do
377         case "$opt" in
378         -*) ;;
379         *) seen_non_option=t; break ;;
380         esac
381 done
382
383 test -n "$seen_non_option" || set "save" "$@"
384
385 # Main command set
386 case "$1" in
387 list)
388         shift
389         list_stash "$@"
390         ;;
391 show)
392         shift
393         show_stash "$@"
394         ;;
395 save)
396         shift
397         save_stash "$@"
398         ;;
399 apply)
400         shift
401         apply_stash "$@"
402         ;;
403 clear)
404         shift
405         clear_stash "$@"
406         ;;
407 create)
408         if test $# -gt 0 && test "$1" = create
409         then
410                 shift
411         fi
412         create_stash "$*" && echo "$w_commit"
413         ;;
414 drop)
415         shift
416         drop_stash "$@"
417         ;;
418 pop)
419         shift
420         if apply_stash "$@"
421         then
422                 drop_stash "$applied_stash"
423         fi
424         ;;
425 branch)
426         shift
427         apply_to_branch "$@"
428         ;;
429 *)
430         case $# in
431         0)
432                 save_stash &&
433                 say '(To restore them type "git stash apply")'
434                 ;;
435         *)
436                 usage
437         esac
438         ;;
439 esac